---
title: text-transform
slug: Web/CSS/text-transform
tags:
  - CSS
  - CSS Property
  - Layout
  - Reference
  - Text
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>text-transform</code></strong> CSS property specifies how to capitalize an element's text. It can be used to make text appear in all-uppercase or all-lowercase, or with each word capitalized. It also can help improve legibility for ruby.</p>

<div>{{EmbedInteractiveExample("pages/css/text-transform.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<p>The <code>text-transform</code> property takes into account language-specific case mapping rules such as the following:</p>

<ul>
 <li>
  <p>In Turkic languages, like Turkish (<code>tr</code>), Azerbaijani (<code>az</code>), Crimean Tatar (<code>crh</code>), Volga Tatar (<code>tt</code>), and Bashkir (<code>ba</code>), there are two kinds of <code>i</code>, with and without the dot, and two case pairings: <code>i</code>/<code>İ</code> and <code>ı</code>/<code>I</code>.</p>
 </li>
 <li>
  <p>In German (<code>de</code>), the <code>ß</code> becomes <code>SS</code> in uppercase.</p>
 </li>
 <li>
  <p>In Dutch (<code>nl</code>), the <code>ij</code> digraph becomes <code>IJ</code>, even with <code>text-transform: capitalize</code>, which only puts the first letter of a word in uppercase.</p>
 </li>
 <li>
  <p>In Greek (<code>el</code>), vowels lose their accent when the whole word is in uppercase (<code>ά</code>/<code>Α</code>), except for the disjunctive <span lang="el">eta</span> (<code>ή</code>/<code>Ή</code>). Also, diphthongs with an accent on the first vowel lose the accent and gain a diaeresis on the second vowel (<code>άι</code>/<code>ΑΪ</code>).</p>
 </li>
 <li>
  <p>In Greek (<code>el</code>), the lowercase sigma character has two forms: <code>σ</code> and <code>ς</code>. <code>ς</code> is used only when sigma terminates a word. When applying <code>text-transform: lowercase</code> to an uppercase sigma (<code>Σ</code>), the browser needs to choose the right lowercase form based on context.</p>
 </li>
 <li>in Irish (<code>ga</code>), certain prefixed letters remain in lowercase when the base initial is capitalized, so for example <code>text-transform: uppercase</code> will change <code>ar aon tslí</code> to <code>AR AON tSLÍ</code> and not, as one might expect, <code>AR AON TSLÍ</code> (Firefox only). In some cases, a hyphen is also removed upon uppercasing: <code>an t-uisce</code> transforms to <code>AN tUISCE</code> (and the hyphen is correctly reinserted by <code>text-transform: lowercase</code>).</li>
</ul>

<p>The language is defined by the <code><a href="/en-US/docs/Web/HTML/Global_attributes/lang">lang</a></code> HTML attribute or the <code><a href="/en-US/docs/Web/SVG/Attribute/xml:lang">xml:lang</a></code> XML attribute.</p>

<div class="note">
<p><strong>Note:</strong> Support for language-specific cases varies between browsers, so check the <a href="#Browser_compatibility">browser compatibility table</a>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
text-transform: none;
text-transform: capitalize;
text-transform: uppercase;
text-transform: lowercase;
text-transform: full-width;
text-transform: full-size-kana;

/* Global values */
text-transform: inherit;
text-transform: initial;
text-transform: unset;
</pre>

<dl>
 <dt><code>capitalize</code></dt>
 <dd>
 <p>Is a keyword that converts the first <em>letter</em> of each word to uppercase. Other characters remain unchanged (they retain their original case as written in the element's text). A letter is defined as a character that is part of Unicode's Letter or Number general categories {{experimental_inline}}; thus, any punctuation marks or symbols at the beginning of a word are ignored.</p>

 <div class="note">Authors should not expect <code>capitalize</code> to follow language-specific title casing conventions (such as skipping articles in English).</div>

 <div class="note">The <code>capitalize</code> keyword was under-specified in CSS 1 and CSS 2.1. This resulted in differences between browsers in the way the first letter was calculated (Firefox considered <code>-</code> and <code>_</code> as letters, but other browsers did not. Both Webkit and Gecko incorrectly considered letter-based symbols like <code>ⓐ</code> to be real letters. Internet Explorer 9 was the closest to the CSS 2 definition, but with some weird cases.) By precisely defining the correct behavior, CSS Text Level 3 cleans this mess up. The <code>capitalize</code> line in the browser compatibility table contains the version the different engines started to support this now precisely-defined behavior.</div>
 </dd>
 <dt><code>uppercase</code></dt>
 <dd>Is a keyword that converts all characters to uppercase.</dd>
 <dt><code>lowercase</code></dt>
 <dd>Is a keyword that converts all characters to lowercase.</dd>
 <dt><code>none</code></dt>
 <dd>Is a keyword that prevents the case of all characters from being changed.</dd>
 <dt><code>full-width</code></dt>
 <dd>Is a keyword that forces the writing of a character — mainly ideograms and Latin scripts — inside a square, allowing them to be aligned in the usual East Asian scripts (like Chinese or Japanese).</dd>
 <dt><code>full-size-kana</code></dt>
 <dd>Generally used for {{htmlelement("ruby")}} annotation text, the keyword converts all small Kana characters to the equivalent full-size Kana, to compensate for legibility issues at the small font sizes typically used in ruby.</dd>
</dl>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Large sections of text set with a <code>text-transform</code> value of <code>uppercase</code> may be difficult for people with cognitive concerns such as Dyslexia to read.</p>

<ul>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable#Guideline_1.4_Make_it_easier_for_users_to_see_and_hear_content_including_separating_foreground_from_background">MDN Understanding WCAG, Guideline 1.4 explanations</a></li>
 <li><a href="https://www.w3.org/TR/WCAG21/#visual-presentation" rel="noopener">W3C Understanding WCAG 2.1</a></li>
</ul>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="none"><code>none</code></h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: none
  &lt;strong&gt;&lt;span&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;
</pre>

<pre class="brush: css notranslate">span {
  text-transform: none;
}
strong { float: right; }</pre>

<p>This demonstrates no text transformation.</p>

<p>{{ EmbedLiveSample('none', '100%', '100px') }}</p>

<h3 id="capitalize_General">capitalize (General)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: capitalize
  &lt;strong&gt;&lt;span&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: capitalize;
}
strong { float: right; }</pre>

<p>This demonstrates text capitalization.</p>

<p>{{ EmbedLiveSample('capitalize_General', '100%', '100px') }}</p>

<h3 id="capitalize_Punctuation">capitalize (Punctuation)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;(this) “is” [a] –short– -test- «for» *the* _css_ ¿capitalize? ?¡transform!&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: capitalize
  &lt;strong&gt;&lt;span&gt;(this) “is” [a] –short– -test- «for» *the* _css_ ¿capitalize? ?¡transform!&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: capitalize;
}
strong { float: right; }</pre>

<p>This demostrates how initial punctuations of a word are ignored. The keyword target the first letter, that is the first Unicode character part of the Letter or Number general category.</p>

<p>{{ EmbedLiveSample('capitalize_Punctuation', '100%', '100px') }}</p>

<h3 id="capitalize_Symbols">capitalize (Symbols)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;ⓐⓑⓒ (ⓓⓔⓕ) —ⓖⓗⓘ— ⓙkl&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: capitalize
  &lt;strong&gt;&lt;span&gt;ⓐⓑⓒ (ⓓⓔⓕ) —ⓖⓗⓘ— ⓙkl&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: capitalize;
}
strong { float: right; }</pre>

<p>This demonstrates how initial symbols are ignored. The keyword target the first letter, that is the first Unicode character part of the Letter or Number general category.</p>

<p>{{ EmbedLiveSample('capitalize_Symbols', '100%', '100px') }}</p>

<h3 id="capitalize_Dutch_ij_digraph">capitalize (Dutch ij digraph)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong lang="nl"&gt;The Dutch word: "<span lang="nl">ijsland</span>" starts with a digraph.&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: capitalize
  &lt;strong&gt;&lt;span lang="nl"&gt;The Dutch word: "<span lang="nl">ijsland</span>" starts with a digraph.&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: capitalize;
}
strong { float: right; }</pre>

<p>This demonstrates how the Dutch <em>ij</em> digraph must be handled like one single letter.</p>

<p>{{ EmbedLiveSample('capitalize_Dutch_ij_digraph', '100%', '100px') }}</p>

<h3 id="uppercase_General">uppercase (General)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: uppercase
  &lt;strong&gt;&lt;span&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: uppercase;
}
strong { float: right; }</pre>

<p>This demonstrates transforming the text to uppercase.</p>

<p>{{ EmbedLiveSample('uppercase_General', '100%', '100px') }}</p>

<h3 id="uppercase_Greek_Vowels">uppercase (Greek Vowels)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Θα πάμε στο "Θεϊκό φαΐ" ή στη "Νεράιδα"&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: uppercase
  &lt;strong&gt;&lt;span&gt;Θα πάμε στο "Θεϊκό φαΐ" ή στη "Νεράιδα"&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: uppercase;
}
strong { float: right; }</pre>

<p>This demonstrates how Greek vowels except disjunctive <em>eta</em> should have no accent, and the accent on the first vowel of a vowel pair becomes a diaeresis on the second vowel.</p>

<p>{{ EmbedLiveSample('uppercase_Greek_Vowels', '100%', '100px') }}</p>

<h3 id="lowercase_General">lowercase (General)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: lowercase
  &lt;strong&gt;&lt;span&gt;Lorem ipsum dolor sit amet, consectetur adipisicing elit, ...&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: lowercase;
}
strong { float: right; }</pre>

<p>This demonstrates transforming the text to lowercase.</p>

<p>{{ EmbedLiveSample('lowercase_General', '100%', '100px') }}</p>

<h3 id="lowercase_Greek_Σ">lowercase (Greek Σ)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Σ IS A greek LETTER that appears SEVERAL TIMES IN ΟΔΥΣΣΕΥΣ.&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: lowercase
  &lt;strong&gt;&lt;span&gt;Σ IS A greek LETTER that appears SEVERAL TIMES IN ΟΔΥΣΣΕΥΣ.&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: lowercase;
}
strong { float: right; }</pre>

<p>This demonstrates how the Greek character sigma (<code>Σ</code>) is transformed into the regular lowercase sigma (<code>σ</code>) or the word-final variant (<code>ς</code>), according the context.</p>

<p>{{ EmbedLiveSample('lowercase_Greek_Σ', '100%', '100px') }}</p>

<h3 id="lowercase_Lithuanian">lowercase (Lithuanian)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;Ĩ is a Lithuanian LETTER as is J́&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: lowercase
  &lt;strong&gt;&lt;span lang="lt"&gt;Ĩ is a Lithuanian LETTER as is J́&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: lowercase;
}
strong { float: right; }</pre>

<p>This demonstrates how the Lithuanian letters <code>Ĩ</code> and <code>J́</code> retain their dot when transformed to lowercase.</p>

<p>{{ EmbedLiveSample('lowercase_Lithuanian', '100%', '100px') }}</p>

<h3 id="full-width_General">full-width (General)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!"#$%&amp;()*+,-./:;&lt;=&gt;?@{|}~&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: full-width
  &lt;strong&gt;&lt;span&gt;0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!"#$%&amp;()*+,-./:;&lt;=&gt;?@{|}~&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: full-width;
}
strong { width: 100%; float: right; }</pre>

<p>Some characters exists in two formats, normal width and a full-width, with different Unicode code points. The full-width version is used to mix them smoothly with Asian ideographic characters.</p>

<p>{{ EmbedLiveSample('full-width_General', '100%', '175px') }}</p>

<h3 id="full-width_Japanese_half-width_katakana">full-width (Japanese half-width katakana)</h3>

<pre class="brush: html notranslate">&lt;p&gt;Initial String
  &lt;strong&gt;ｳｪﾌﾞﾌﾟﾛｸﾞﾗﾐﾝｸﾞの勉強&lt;/strong&gt;
&lt;/p&gt;
&lt;p&gt;text-transform: full-width
  &lt;strong&gt;&lt;span&gt;ｳｪﾌﾞﾌﾟﾛｸﾞﾗﾐﾝｸﾞの勉強&lt;/span&gt;&lt;/strong&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">span {
  text-transform: full-width;
}
strong { width: 100%; float: right; }</pre>

<p>The Japanese half-width katakana was used to represent katakana in 8-bit character codes. Unlike regular (full-width) katakana characters, a letter with dakuten (voiced sound mark) is represented as two code points, the body of letter and dakuten. The <code>full-width</code> combines these into a single code point when converting these characters into full-width.</p>

<p>{{ EmbedLiveSample('full-width_Japanese_half-width_katakana', '100%', '175px') }}</p>

<h3 id="full-size-kana">full-size-kana</h3>

<pre class="brush: html notranslate">&lt;p&gt;ァィゥェ ォヵㇰヶ ㇱㇲッㇳ ㇴㇵㇶㇷ ㇸㇹㇺャ ュョㇻㇼ ㇽㇾㇿヮ&lt;/p&gt;
&lt;p&gt;ァィゥェ ォヵㇰヶ ㇱㇲッㇳ ㇴㇵㇶㇷ ㇸㇹㇺャ ュョㇻㇼ ㇽㇾㇿヮ&lt;/p&gt;
&lt;/p&gt;</pre>

<pre class="brush: css notranslate">p:nth-of-type(2) {
  text-transform: full-size-kana;
}</pre>

<p>{{ EmbedLiveSample('full-size-kana', '100%', '175px') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Text', '#text-transform', 'text-transform')}}</td>
   <td>{{Spec2('CSS3 Text')}}</td>
   <td>From {{SpecName('CSS2.1', 'text.html#caps-prop', 'text-transform')}}, extends letters to any Unicode character in the Number or Letter general category. Modifies the behavior of <code>capitalize</code> to apply to the first letter of the word, ignoring initial punctuations or symbols. Adds the <code>full-width</code> and <code>full-size-kana</code> keywords.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'text.html#caps-prop', 'text-transform')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>From {{SpecName('CSS1', '#text-transform', 'text-transform')}}, extends letters to non-latin bi-cameral scripts</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS1', '#text-transform', 'text-transform')}}</td>
   <td>{{Spec2('CSS1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.text-transform")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("font-variant")}}</li>
</ul>
